
#include <string.h>
#include <mem.h>

#include "cgdk.h"
//#include "vesa.h"
#include "keyb.h"
#include "svga.h"
//#include "vga.h"
#include "lin.h"
//#include "b256.h"

#include "b256c_.cpp"


void B256_clear (long color)
{
  #ifndef CGDK_TRIAL

  int i;
  long a;

  a = (long)SVGA_scanLines*SVGA_virtualX;/*SVGA_bytesPerPixel**/

  for (i = 0; i < hi (a); i++)
  {
    VESA_setBank (i);
    memset (SVGA_videoBuf, color, 0xFFFF);
    *((char *)SVGA_videoBuf+0xFFFF) = color;
  }
  VESA_setBank (i);
  memset (SVGA_videoBuf, color, lo (a));

  #endif
}




static void B256_movRaw (int pos, void *win, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  int maxY;
  int rest;
  int bank;
  int virtualX = SVGA_virtualX;
  char *spr = (char *) win;
  char *dst;
  char *videoBuf = (char *) SVGA_videoBuf;

  bank = hi (pos);
  VESA_setBank (bank);
  dst = videoBuf;

  while (sizeY > 0)
  {
    rest = 65536L - lo (pos);
    maxY = rest / virtualX;
    dst += lo (pos);

    if (maxY < sizeY)
    {
      rest = rest % virtualX;
      if (rest >= sizeX)
      {
        rest = 0;
        maxY++;
      }

      LIN_movWin_ (dst, virtualX, spr, formatX, sizeX, maxY);
      bank++;
      spr += maxY * formatX;

      if (rest)
      {
        dst += maxY * virtualX;
        LIN_movWin_ (dst, virtualX, spr, formatX, rest, 1);
        dst = videoBuf;
        VESA_setBank (bank);
        LIN_movWin_  (dst, virtualX, spr + rest, formatX, sizeX - rest, 1);
        maxY++;
        spr += formatX;
        sizeY -= maxY;
      }
      else
      {
        sizeY -= maxY;
        if (sizeY)
        {
          dst = videoBuf;
          VESA_setBank (bank);
        }
        else
          break;
      }

      pos += maxY * virtualX;
    }
    else
    {
      LIN_movWin_ (dst, virtualX, spr, formatX, sizeX, sizeY);
      break;
    }
  }

  #endif
}

static void B256_getRaw (int pos, void *win, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  int maxY;
  int rest;
  int bank;
  int virtualX = SVGA_virtualX;
  char *spr = (char *) win;
  char *dst;
  char *videoBuf = (char *) SVGA_videoBuf;

  bank = hi (pos);
  VESA_setBank (bank);
  dst = videoBuf;

  while (sizeY > 0)
  {
    rest = 65536L - lo (pos);
    maxY = rest / virtualX;
    dst += lo (pos);

    if (maxY < sizeY)
    {
      rest = rest % virtualX;
      if (rest >= sizeX)
      {
        rest = 0;
        maxY++;
      }

      LIN_movWin_ (spr, formatX, dst, virtualX, sizeX, maxY);
      bank++;
      spr += maxY * formatX;

      if (rest)
      {
        dst += maxY * virtualX;
        LIN_movWin_ (spr, formatX, dst, virtualX, rest, 1);
        dst = videoBuf;
        VESA_setBank (bank);
        LIN_movWin_  (spr + rest, formatX, dst, virtualX, sizeX - rest, 1);
        maxY++;
        spr += formatX;
        sizeY -= maxY;
      }
      else
      {
        sizeY -= maxY;
        if (sizeY)
        {
          dst = videoBuf;
          VESA_setBank (bank);
        }
        else
          break;
      }

      pos += maxY * virtualX;
    }
    else
    {
      LIN_movWin_ (spr, formatX, dst, virtualX, sizeX, sizeY);
      break;
    }
  }

  #endif
}



static void B256_movSprRaw (int pos, void *win, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  int maxY;
  int rest;
  int bank;
  int virtualX = SVGA_virtualX;
  char *spr = (char *) win;
  char *dst;
  char *videoBuf = (char *) SVGA_videoBuf;

  bank = hi (pos);
  VESA_setBank (bank);
  dst = videoBuf;

  while (sizeY > 0)
  {
    rest = 65536L - lo (pos);
    maxY = rest / virtualX;
    dst += lo (pos);

    if (maxY < sizeY)
    {
      rest = rest % virtualX;
      if (rest >= sizeX)
      {
        rest = 0;
        maxY++;
      }

      LIN_movSpr_ (dst, virtualX, spr, formatX, sizeX, maxY);
      bank++;
      spr += maxY * formatX;

      if (rest)
      {
        dst += maxY * virtualX;
        LIN_movSpr_ (dst, virtualX, spr, formatX, rest, 1);
        dst = videoBuf;
        VESA_setBank (bank);
        LIN_movSpr_  (dst, virtualX, spr + rest, formatX, sizeX - rest, 1);
        maxY++;
        spr += formatX;
        sizeY -= maxY;
      }
      else
      {
        sizeY -= maxY;
        if (sizeY)
        {
          dst = videoBuf;
          VESA_setBank (bank);
        }
        else
          break;
      }

      pos += maxY * virtualX;
    }
    else
    {
      LIN_movSpr_ (dst, virtualX, spr, formatX, sizeX, sizeY);
      break;
    }
  }

  #endif
}


static void B256_movRaw2 (int voff, void *win, int SIZE_X, int SIZE_Y, int formatX)
{
  #ifndef CGDK_TRIAL

  int sizeX, sizeY;
  int restX, restY;;
  char *spr = (char *) win;
  int virt = SVGA_virtual;
  int virt2 = SVGA_virtual2;
  int virtX = SVGA_virtualX;

  voff += virt;

  sizeY = (virt2-voff)/virtX;

  if (sizeY > SIZE_Y)
  {
    B256_movRaw (voff, spr, SIZE_X, SIZE_Y, formatX);
  }
  else
  {
    if (sizeY)
    {
      B256_movRaw (voff, spr, SIZE_X, sizeY, formatX);
    }

    restY = SIZE_Y-sizeY-1;
    if (restY >= 0)
    {
      spr+=sizeY*formatX;
      voff+=sizeY*virtX;

      restX = virt2 - voff;

      sizeX = (restX > SIZE_X) ? SIZE_X : restX;

      B256_movRaw (voff, spr, sizeX, 1, sizeX);
      B256_movRaw (0, spr+sizeX, SIZE_X-sizeX, 1, SIZE_X-sizeX);

      if (restY)
      {
        spr += formatX;
        voff = virtX - restX;

        B256_movRaw (voff, spr, SIZE_X, restY, formatX);
      }
    }
  }

  #endif
}

static void B256_movSprRaw2 (int voff, void *win, int SIZE_X, int SIZE_Y, int formatX)
{
  #ifndef CGDK_TRIAL

  int sizeX, sizeY;
  int restX, restY;;
  char *spr = (char *) win;
  int virt = SVGA_virtual;
  int virt2 = SVGA_virtual2;
  int virtX = SVGA_virtualX;

  voff += virt;

  sizeY = (virt2-voff)/virtX;

  if (sizeY > SIZE_Y)
  {
    B256_movSprRaw (voff, spr, SIZE_X, SIZE_Y, formatX);
  }
  else
  {
    if (sizeY)
    {
      B256_movSprRaw (voff, spr, SIZE_X, sizeY, formatX);
    }

    restY = SIZE_Y-sizeY-1;
    if (restY >= 0)
    {
      spr+=sizeY*formatX;
      voff+=sizeY*virtX;

      restX = virt2 - voff;

      sizeX = (restX > SIZE_X) ? SIZE_X : restX;

      B256_movSprRaw (voff, spr, sizeX, 1, sizeX);
      B256_movSprRaw (0, spr+sizeX, SIZE_X-sizeX, 1, SIZE_X-sizeX);

      if (restY)
      {
        spr += formatX;
        voff = virtX - restX;

        B256_movSprRaw (voff, spr, SIZE_X, restY, formatX);
      }
    }
  }

  #endif
}




void B256_movWin2 (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  long pos;

  x += SVGA_curX;
  y += SVGA_curY;
  SVGA_virtual2Real (&x, &y);

  pos = x + y * SVGA_virtualX;

  B256_movRaw (pos, win, sizeX, sizeY,formatX);

  B256_movRaw2 (pos, win, sizeX, sizeY, formatX);

  #endif
}

void B256_movWin (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  long pos;

  x += SVGA_curX;
  y += SVGA_curY;
  SVGA_virtual2Real (&x, &y);

  pos = x + y * SVGA_virtualX;

  B256_movRaw (pos, win, sizeX,sizeY,formatX);

  #endif
}

void B256_getWin (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  long pos;

  x += SVGA_curX;
  y += SVGA_curY;
  SVGA_virtual2Real (&x, &y);

  pos = x + y * SVGA_virtualX;

  B256_getRaw (pos, win, sizeX,sizeY,formatX);

  #endif
}

void B256_movWinMirror (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  long pos;

  x += SVGA_curX;
  y += SVGA_curY;
  SVGA_virtual2Real (&x, &y);

  pos = x + y * SVGA_virtualX;

  B256_movRaw2 (pos, win, sizeX,sizeY,formatX);

  #endif
}

void B256_movSpr2 (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  long pos;

  x += SVGA_curX;
  y += SVGA_curY;
  SVGA_virtual2Real (&x, &y);

  pos = x + y * SVGA_virtualX;

  B256_movSprRaw (pos, win, sizeX, sizeY,formatX);

  B256_movSprRaw2 (pos, win, sizeX, sizeY, formatX);

  #endif
}

void B256_movSpr (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  long pos;

  x += SVGA_curX;
  y += SVGA_curY;
  SVGA_virtual2Real (&x, &y);

  pos = x + y * SVGA_virtualX;

  B256_movSprRaw (pos, win, sizeX,sizeY,formatX);

  #endif
}

void B256_movSprMirror (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  long pos;

  x += SVGA_curX;
  y += SVGA_curY;
  SVGA_virtual2Real (&x, &y);

  pos = x + y * SVGA_virtualX;

  B256_movSprRaw2 (pos, win, sizeX,sizeY,formatX);

  #endif
}












static void B256_putRaw (int pos, void *win, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  int maxY;
  int rest;
  int bank;
  int virtualX = SVGA_virtualX;
  char *spr = (char *) win;
  char *dst;
  char *videoBuf = (char *) SVGA_videoBuf;

  bank = hi (pos);
  dst = videoBuf;

  while (sizeY > 0)
  {
    rest = 65536L - lo (pos);
    maxY = rest / virtualX;
    dst += lo (pos);

    if (maxY < sizeY)
    {
      rest = rest % virtualX;
      if (rest >= sizeX)
      {
        rest = 0;
        maxY++;
      }

      B256C_putWin (bank, dst, virtualX, spr, formatX, sizeX, maxY);
      bank++;
      spr += maxY * formatX;

      if (rest)
      {
        dst += maxY * virtualX;
        B256C_putWin (bank-1, dst, virtualX, spr, formatX, rest, 1);
        dst = videoBuf;
        B256C_putWin  (bank, dst, virtualX, spr + rest, formatX, sizeX - rest, 1);
        maxY++;
        spr += formatX;
        sizeY -= maxY;
      }
      else
      {
        sizeY -= maxY;
        if (sizeY)
        {
          dst = videoBuf;
        }
        else
          break;
      }

      pos += maxY * virtualX;
    }
    else
    {
      B256C_putWin (bank, dst, virtualX, spr, formatX, sizeX, sizeY);
      break;
    }
  }

  #endif
}



static void B256_putSprRaw (int pos, void *win, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  int maxY;
  int rest;
  int bank;
  int virtualX = SVGA_virtualX;
  char *spr = (char *) win;
  char *dst;
  char *videoBuf = (char *) SVGA_videoBuf;

  bank = hi (pos);
  dst = videoBuf;

  while (sizeY > 0)
  {
    rest = 65536L - lo (pos);
    maxY = rest / virtualX;
    dst += lo (pos);

    if (maxY < sizeY)
    {
      rest = rest % virtualX;
      if (rest >= sizeX)
      {
        rest = 0;
        maxY++;
      }

      B256C_putSpr (bank, dst, virtualX, spr, formatX, sizeX, maxY);
      bank++;
      spr += maxY * formatX;

      if (rest)
      {
        dst += maxY * virtualX;
        B256C_putSpr (bank-1,dst, virtualX, spr, formatX, rest, 1);
        dst = videoBuf;
        B256C_putSpr  (bank, dst, virtualX, spr + rest, formatX, sizeX - rest, 1);
        maxY++;
        spr += formatX;
        sizeY -= maxY;
      }
      else
      {
        sizeY -= maxY;
        if (sizeY)
        {
          dst = videoBuf;
        }
        else
          break;
      }

      pos += maxY * virtualX;
    }
    else
    {
      B256C_putSpr (bank, dst, virtualX, spr, formatX, sizeX, sizeY);
      break;
    }
  }

  #endif
}


static void B256_putRaw2 (int voff, void *win, int SIZE_X, int SIZE_Y, int formatX)
{
  #ifndef CGDK_TRIAL

  int sizeX, sizeY;
  int restX, restY;;
  char *spr = (char *) win;
  int virt = SVGA_virtual;
  int virt2 = SVGA_virtual2;
  int virtX = SVGA_virtualX;

  voff += virt;

  sizeY = (virt2-voff)/virtX;

  if (sizeY > SIZE_Y)
  {
    B256_putRaw (voff, spr, SIZE_X, SIZE_Y, formatX);
  }
  else
  {
    if (sizeY)
    {
      B256_putRaw (voff, spr, SIZE_X, sizeY, formatX);
    }

    restY = SIZE_Y-sizeY-1;
    if (restY >= 0)
    {
      spr+=sizeY*formatX;
      voff+=sizeY*virtX;

      restX = virt2 - voff;

      sizeX = (restX > SIZE_X) ? SIZE_X : restX;

      B256_putRaw (voff, spr, sizeX, 1, sizeX);
      B256_putRaw (0, spr+sizeX, SIZE_X-sizeX, 1, SIZE_X-sizeX);

      if (restY)
      {
        spr += formatX;
        voff = virtX - restX;

        B256_putRaw (voff, spr, SIZE_X, restY, formatX);
      }
    }
  }

  #endif
}

static void B256_putSprRaw2 (int voff, void *win, int SIZE_X, int SIZE_Y, int formatX)
{
  #ifndef CGDK_TRIAL

  int sizeX, sizeY;
  int restX, restY;;
  char *spr = (char *) win;
  int virt = SVGA_virtual;
  int virt2 = SVGA_virtual2;
  int virtX = SVGA_virtualX;

  voff += virt;

  sizeY = (virt2-voff)/virtX;

  if (sizeY > SIZE_Y)
  {
    B256_putSprRaw (voff, spr, SIZE_X, SIZE_Y, formatX);
  }
  else
  {
    if (sizeY)
    {
      B256_putSprRaw (voff, spr, SIZE_X, sizeY, formatX);
    }

    restY = SIZE_Y-sizeY-1;
    if (restY >= 0)
    {
      spr+=sizeY*formatX;
      voff+=sizeY*virtX;

      restX = virt2 - voff;

      sizeX = (restX > SIZE_X) ? SIZE_X : restX;

      B256_putSprRaw (voff, spr, sizeX, 1, sizeX);
      B256_putSprRaw (0, spr+sizeX, SIZE_X-sizeX, 1, SIZE_X-sizeX);

      if (restY)
      {
        spr += formatX;
        voff = virtX - restX;

        B256_putSprRaw (voff, spr, SIZE_X, restY, formatX);
      }
    }
  }

  #endif
}



void B256_putWin2 (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  long pos;

  x += SVGA_curX;
  y += SVGA_curY;
  SVGA_virtual2Real (&x, &y);

  pos = x + y * SVGA_virtualX;

  B256_putRaw (pos, win, sizeX, sizeY,formatX);

  B256_putRaw2 (pos, win, sizeX, sizeY, formatX);

  #endif
}

void B256_putWin (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  long pos;

  x += SVGA_curX;
  y += SVGA_curY;
  SVGA_virtual2Real (&x, &y);

  pos = x + y * SVGA_virtualX;

  B256_putRaw (pos, win, sizeX,sizeY,formatX);

  #endif
}

void B256_putSpr2 (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  long pos;

  x += SVGA_curX;
  y += SVGA_curY;
  SVGA_virtual2Real (&x, &y);

  pos = x + y * SVGA_virtualX;

  B256_putSprRaw (pos, win, sizeX, sizeY,formatX);

  B256_putSprRaw2 (pos, win, sizeX, sizeY, formatX);

  #endif
}

void B256_putSpr (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  #ifndef CGDK_TRIAL

  long pos;

  x += SVGA_curX;
  y += SVGA_curY;
  SVGA_virtual2Real (&x, &y);

  pos = x + y * SVGA_virtualX;

  B256_putSprRaw (pos, win, sizeX,sizeY,formatX);

  #endif
}

/*
void B256_movPixel (int x,int y,long color)
{
  #ifndef CGDK_TRIAL

  if (SVGA_doubleBuffer)
  {
    B256_movWin2 (&color, x, y, 1, 1, 1);
  }
  else
  {
    B256_movWin (&color, x, y, 1, 1, 1);
  }

  #endif
}
*/

long B256_getPixel (int x,int y)
{
  #ifndef CGDK_TRIAL

  long a;

  a = x + y*SVGA_bytesPerPixel*SVGA_maxX;
  VESA_setBank (hi (a));

  return ((char *) SVGA_videoBuf) [lo (a)];

  #else
  return 0;
  #endif
}

void B256_putPixel (int x,int y,long color)
{
  #ifndef CGDK_TRIAL

  char c = color;

  if (SVGA_doubleBuffer)
  {
    B256_movWin2 (&c, x, y, 1, 1, 1);
  }
  else
  {
    B256_movWin (&c, x, y, 1, 1, 1);
  }

  #endif
}


/*

void B256_putSpr_  (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  int i;
  long a;
  long Offset = 0;
  long Count;
  unsigned voffset;
  unsigned vbank;

  x += SVGA_curX;
  y += SVGA_curY;
  SVGA_virtual2Real (&x, &y);

  if (win != NULL)
  {
    if (sizeX)
    {
      a = x + (long)y*SVGA_virtualX;//*SVGA_maxX*SVGA_bytesPerPixel
      for (i = 0; i < sizeY ; i++)
      {
        voffset = lo (a);
        vbank = hi (a);
        VESA_setBank (vbank);
        Count = 65536L-voffset;
        if (Count >= sizeX)
        {
          LIN_sprcpy ((char *)SVGA_videoBuf+ voffset, ((char *)win + Offset), sizeX);
        }
        else
        {
          LIN_sprcpy ((char *)SVGA_videoBuf+ voffset, ((char *)win + Offset), Count);
          VESA_setBank (vbank +1);
          LIN_sprcpy ((char *)SVGA_videoBuf, ((char *)win + Offset+Count), sizeX-Count);
        }
        a += SVGA_virtualX;//*SVGA_maxX*SVGA_bytesPerPixel
        Offset += formatX;
      }
    }
  }
}



void B256_putSprMirror_ (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  int i,j;
  long breakPoint, curPoint, sprOffset;
  char c;

  x += SVGA_curX;
  y += SVGA_curY;
  SVGA_virtual2Real (&x, &y);

  if (win != NULL)
  {
    if (sizeX)
    {
      sprOffset = 0;
      curPoint = SVGA_virtual + x + (long)y*SVGA_virtualX;//*SVGA_maxX*SVGA_bytesPerPixel
      breakPoint = 2*SVGA_virtual;
      for (j = 0; j < sizeY ; j++)
      {
        for (i = 0; i < sizeX; i++)
        {
          if (curPoint > breakPoint)
          {
            curPoint -= breakPoint;
          }
          VESA_setBank (curPoint >> 16);
          c = ((char *)win) [sprOffset];
          if (c)
          {
            ((char *)SVGA_videoBuf) [curPoint & 0xFFFF] = c;
          }
          curPoint++;
          sprOffset++;
        }
        curPoint+=SVGA_virtualX-sizeX;
        sprOffset+=formatX-sizeX;
      }
    }
  }
}


void B256_putSpr2_ (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  B256_putSpr_ (win,x,y,sizeX,sizeY,formatX);

  B256_putSprMirror_ (win, x, y, sizeX, sizeY, formatX);
}
*/

/*
void B256_putWin  (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  int i;
  long a;
  long Offset = 0;
  long Count;
  unsigned voffset;
  unsigned vbank;

  if (win != NULL)
  {
    if (sizeX)
    {
      x += SVGA_curX;
      y += SVGA_curY;
      SVGA_virtual2Real (&x, &y);

      a = x + (long)y*SVGA_virtualX;//*SVGA_maxX*SVGA_bytesPerPixel
      for (i = 0; i < sizeY ; i++)
      {
        voffset = lo (a);
        vbank = hi (a);
        VESA_setBank (vbank);
        Count = 65536L-voffset;
        if (Count >= sizeX)
        {
          memcpy ((char *)SVGA_videoBuf+ voffset, ((char *)win + Offset), sizeX);
        }
        else
        {
          memcpy ((char *)SVGA_videoBuf+ voffset, ((char *)win + Offset), Count);
          VESA_setBank (vbank +1);
          memcpy ((char *)SVGA_videoBuf, ((char *)win + Offset+Count), sizeX-Count);
        }
        a += SVGA_virtualX;//*SVGA_maxX*SVGA_bytesPerPixel
        Offset += formatX;
      }
    }
  }
}
*/
/*
void B256_putWinMirror_ (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  int i,j;
  long breakPoint, curPoint, sprOffset;

  if (win != NULL)
  {
    if (sizeX)
    {
      x += SVGA_curX;
      y += SVGA_curY;
      SVGA_virtual2Real (&x, &y);

      sprOffset = 0;
      curPoint = SVGA_virtual + x + (long)y*SVGA_virtualX;//*SVGA_maxX*SVGA_bytesPerPixel
      breakPoint = 2*SVGA_virtual;
      for (j = 0; j < sizeY ; j++)
      {
        for (i = 0; i < sizeX; i++)
        {
          if (curPoint >= breakPoint)
          {
            curPoint -= breakPoint;
          }
          VESA_setBank (curPoint >> 16);
          ((char *)SVGA_videoBuf) [curPoint & 0xFFFF] = ((char *)win) [sprOffset];
          curPoint++;
          sprOffset++;
        }
        curPoint+=SVGA_virtualX-sizeX;
        sprOffset+=formatX-sizeX;
      }
    }
  }
}
*/

/*
void B256_getWin_ (void *win, int x, int y, int sizeX, int sizeY, int formatX)
{
  int i;
  long a;
  long Offset = 0;
  long Count;
  unsigned int voffset;
  unsigned int vbank;

  if (win != NULL)
  {
    if (sizeX)
    {
      x += SVGA_curX;
      y += SVGA_curY;
      SVGA_virtual2Real (&x, &y);

      a = x + (long)y*SVGA_virtualX;//*SVGA_maxX*SVGA_bytesPerPixel
      for (i = 0; i < sizeY ; i++)
      {
        voffset = lo (a);
        vbank = hi (a);
        VESA_setBank (vbank);
        Count = 65536L-voffset;
        if (Count >= sizeX)
        {
          memcpy (((char *)win + Offset), (char *)SVGA_videoBuf+ voffset, sizeX);
        }
        else
        {
          memcpy (((char *)win + Offset), (char *)SVGA_videoBuf+ voffset, Count);
          VESA_setBank (vbank +1);
          memcpy (((char *)win + Offset+Count), SVGA_videoBuf, sizeX-Count);
        }
        a += SVGA_virtualX;//*SVGA_maxX*SVGA_bytesPerPixel
        Offset += formatX;
      }
    }
  }
}
*/
