
#ifndef _JSTICK_H
  #define _JSTICK_H
  
  #ifdef __cplusplus
  extern "C" {
  #endif


  #define JOY_DETECTED_A 1
  #define JOY_DETECTED_B 2
  #define JOY_DETECTED_BOTH (JOY_DETECTED_A | JOY_DETECTED_B)

  #define JOY_DETECTED 1
  #define JOY_NOTDETECTED -1
  #define JOY_BUTTONPRESSED 1
  #define JOY_BUTTONRELEASED 0

  #define JOY_LEFT 1
  #define JOY_RIGHT 2
  #define JOY_UP 4
  #define JOY_DOWN 8

  typedef struct
  {
    int installed;
    int button1;
    int button2;
    int axisX;
    int axisY;
    int minX;
    int maxX;
    int minY;
    int maxY;
  } TJOY;

  typedef struct
  {
    TJOY a,b;
    int mask;
  } TJOY_state;

  extern TJOY_state JOY_state;

  int JOY_init (void);
  void JOY_read (void);
  void JOY_moveUpperLeftA (void);
  void JOY_moveUpperLeftB (void);
  void JOY_moveLowerRightA (void);
  void JOY_moveLowerRightB (void);
  int JOY_positionA (void);
  #define JOY_calibratedA (JOY_state.a.maxX != 0)
  #define JOY_calibratedB (JOY_state.b.maxX != 0)

  #ifdef __cplusplus
  }
  #endif

#endif
